'Adafruit Test#2
'Turn a single pixel on white

CON  'Crystal settings

  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

CON  'Pin settings

  Pin_R1 = 4    '1  on connector
  Pin_G1 = 5    '2
  Pin_B1 = 6    '3
  Pin_R2 = 7    '5
  Pin_G2 = 8    '6
  Pin_B2 = 9    '7
  Pin_A  = 10   '9     'ABC select section
  Pin_B  = 11   '10
  Pin_C  = 12   '11
  Pin_CLK= 13   '13    'clock
  Pin_LE = 14   '14    'latch enable
  Pin_EN = 15   '15    'display enable


PUB Main|i, j, section,half,bit  'Show a single white pixel
  'Set a pixel of given section, half, and bit
  section:=3  '0..7
  half:=1  '1..2
  bit:=10  '0..31

  'Set all pins to output low
  OUTA[Pin_R1..Pin_EN]~  
  DIRA[Pin_R1..Pin_EN]~~

  i:=0   'initialize main loop section iterator
  
  repeat  'Main loop
    'Shift out the data for current section
    repeat j from 0 to 31
      OUTA[Pin_R1..Pin_B2]~  'start with all zeros
      if i==section and j==bit  'if this is the right bit position
        'set rgb in our half to one
        if half==1
          OUTA[pin_R1..pin_B1]~~
        else
          OUTA[pin_R2..pin_B2]~~ 

      'Toggle the clock          
      OUTA[Pin_CLK]~~
      OUTA[Pin_CLK]~    

    'disable display while latching and selecting this section
    OUTA[Pin_EN]~~ 
     
    'Latch the data
    OUTA[Pin_LE]~~
    OUTA[Pin_LE]~
      
    'Select this section
    OUTA[Pin_C..Pin_A]:=i
    if i++==8  'keep i in range 0..7
      i:=0

    'enable display now that data latched and section selected
    OUTA[Pin_EN]~ 

   
